Alte Stylesheets entfernt. Wir haben ja Themes.
[people/pmueller/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.0rc2t" # Version number
28 SLOGAN="www.ipfire.org" # Software slogan
29 CONFIG_ROOT=/var/ipfire # Configuration rootdir
30 NICE=10 # Nice level
31 MAX_RETRIES=1 # prefetch/check loop
32 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33 MACHINE=`uname -m`
34 SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36 IPFVER="full" # Which versions should be compiled? (full|devel)
37
38 # Set an information about the build number
39 if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41 fi
42
43 # Debian specific settings
44 if [ ! -e /etc/debian_version ]; then
45 FULLPATH=`which $0`
46 else
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
53 fi
54
55 PWD=`pwd`
56 BASENAME=`basename $0`
57 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58 LOGFILE=$BASEDIR/log/_build.preparation.log
59 export BASEDIR LOGFILE
60 DIR_CHK=$BASEDIR/cache/check
61 mkdir $BASEDIR/log/ 2>/dev/null
62
63 # Include funtions
64 . tools/make-functions
65
66 if [ -f .config ]; then
67 . .config
68 else
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
76 fi
77
78 prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
111 else
112 beautify message DONE
113 fi
114
115
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
122 if [ `id -u` != 0 ]; then
123 beautify message FAIL
124 exiterror "Not building as root"
125 else
126 beautify message DONE
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
138 if (( 2048000 > $BASE_ASPACE )); then
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
144 else
145 beautify message DONE
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
173 MAKETUNING="-j6"
174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
185
186 # Make all sources and proc available under lfs build
187 mount --bind /dev $BASEDIR/build/dev
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
202 # This is a temporary hack!!!
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
206
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213 }
214
215 buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
227 lfsmake1 cleanup-toolchain PASS=1
228 lfsmake1 tcl
229 lfsmake1 expect
230 lfsmake1 dejagnu
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
233 lfsmake1 ncurses
234 lfsmake1 bash
235 lfsmake1 bzip2
236 lfsmake1 coreutils
237 lfsmake1 diffutils
238 lfsmake1 findutils
239 lfsmake1 gawk
240 lfsmake1 gettext
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
245 lfsmake1 patch
246 lfsmake1 perl
247 lfsmake1 sed
248 lfsmake1 tar
249 lfsmake1 texinfo
250 lfsmake1 util-linux
251 lfsmake1 cleanup-toolchain PASS=2
252 export PATH=$ORG_PATH
253 }
254
255 buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
258 lfsmake2 stage2
259 lfsmake2 linux-libc-header
260 lfsmake2 man-pages
261 lfsmake2 glibc
262 lfsmake2 cleanup-toolchain PASS=3
263 lfsmake2 binutils
264 lfsmake2 gcc
265 lfsmake2 berkeley
266 lfsmake2 coreutils
267 lfsmake2 iana-etc
268 lfsmake2 m4
269 lfsmake2 bison
270 lfsmake2 ncurses
271 lfsmake2 procps
272 lfsmake2 sed
273 lfsmake2 libtool
274 lfsmake2 perl
275 lfsmake2 readline
276 lfsmake2 zlib
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
280 lfsmake2 bzip2
281 lfsmake2 diffutils
282 lfsmake2 e2fsprogs
283 lfsmake2 ed
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
291 lfsmake2 gzip
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
296 lfsmake2 libaal
297 lfsmake2 make
298 lfsmake2 man
299 lfsmake2 mktemp
300 lfsmake2 modutils
301 lfsmake2 mtd
302 lfsmake2 net-tools
303 lfsmake2 patch
304 lfsmake2 psmisc
305 lfsmake2 reiser4progs
306 lfsmake2 shadow
307 lfsmake2 sysklogd
308 lfsmake2 sysvinit
309 lfsmake2 tar
310 lfsmake2 texinfo
311 lfsmake2 udev
312 lfsmake2 util-linux
313 lfsmake2 vim
314 lfsmake2 grub
315 }
316
317 buildipfire() {
318 LOGFILE="$BASEDIR/log/_build.ipfire.log"
319 export LOGFILE
320 ipfiremake configroot
321 ipfiremake backup
322 ipfiremake dhcp
323 ipfiremake dhcpcd
324 ipfiremake libusb
325 ipfiremake libpcap
326 ipfiremake ppp
327 ipfiremake rp-pppoe
328 ipfiremake unzip
329 ipfiremake linux SMP=1
330 ipfiremake ipp2p SMP=1
331 ipfiremake zaptel SMP=1
332 ipfiremake linux
333 ipfiremake ipp2p
334 ipfiremake zaptel
335 ipfiremake pkg-config
336 ipfiremake linux-atm
337 ipfiremake cpio
338 ipfiremake klibc
339 ipfiremake mkinitcpio
340 ipfiremake udev KLIBC=1
341 ipfiremake expat
342 ipfiremake gdbm
343 ipfiremake gmp
344 ipfiremake pam
345 ipfiremake openssl
346 ipfiremake curl
347 ipfiremake python
348 ipfiremake libnet
349 ipfiremake libidn
350 ipfiremake libjpeg
351 ipfiremake libpng
352 ipfiremake libtiff
353 ipfiremake libart
354 ipfiremake freetype
355 ipfiremake gd
356 ipfiremake popt
357 ipfiremake pcre
358 ipfiremake slang
359 ipfiremake newt
360 ipfiremake libcap
361 ipfiremake pciutils
362 ipfiremake usbutils
363 ipfiremake libxml2
364 ipfiremake libxslt
365 ipfiremake BerkeleyDB
366 ipfiremake mysql
367 ipfiremake cyrus-sasl
368 ipfiremake openldap
369 ipfiremake apache2
370 ipfiremake php
371 ipfiremake apache2 PASS=C
372 ipfiremake arping
373 ipfiremake beep
374 ipfiremake bind
375 ipfiremake cdrtools
376 ipfiremake dnsmasq
377 ipfiremake dosfstools
378 ipfiremake squashfstools
379 ipfiremake reiserfsprogs
380 ipfiremake sysfsutils
381 ipfiremake fuse
382 ipfiremake ntfs-3g
383 ipfiremake ethtool
384 ipfiremake ez-ipupdate
385 ipfiremake fcron
386 ipfiremake perl-GD
387 ipfiremake GD-Graph
388 ipfiremake GD-TextUtil
389 ipfiremake gnupg
390 ipfiremake hdparm
391 ipfiremake sdparm
392 ipfiremake mtools
393 ipfiremake initscripts
394 ipfiremake whatmask
395 ipfiremake iptables
396 ipfiremake libupnp
397 ipfiremake ipp2p IPT=1
398 ipfiremake linux-igd
399 ipfiremake ipac-ng
400 ipfiremake ipaddr
401 ipfiremake iptstate
402 ipfiremake iputils
403 ipfiremake l7-protocols
404 ipfiremake mISDN
405 ipfiremake hwdata
406 ipfiremake kudzu
407 ipfiremake logrotate
408 ipfiremake logwatch
409 ipfiremake misc-progs
410 ipfiremake nano
411 ipfiremake nasm
412 ipfiremake URI
413 ipfiremake HTML-Tagset
414 ipfiremake HTML-Parser
415 ipfiremake Compress-Zlib
416 ipfiremake Digest
417 ipfiremake Digest-SHA1
418 ipfiremake Digest-HMAC
419 ipfiremake libwww-perl
420 ipfiremake Net-DNS
421 ipfiremake Net-IPv4Addr
422 ipfiremake Net_SSLeay
423 ipfiremake IO-Stringy
424 ipfiremake Unix-Syslog
425 ipfiremake Mail-Tools
426 ipfiremake MIME-Tools
427 ipfiremake Net-Server
428 ipfiremake Convert-TNEF
429 ipfiremake Convert-UUlib
430 ipfiremake Archive-Tar
431 ipfiremake Archive-Zip
432 ipfiremake Text-Tabs+Wrap
433 ipfiremake Locale-Country
434 ipfiremake XML-Parser
435 ipfiremake glib
436 ipfiremake GeoIP
437 ipfiremake fwhits
438 ipfiremake noip_updater
439 ipfiremake ntp
440 ipfiremake openssh
441 ipfiremake openswan
442 ipfiremake rrdtool
443 ipfiremake setserial
444 ipfiremake setup
445 ipfiremake snort
446 ipfiremake oinkmaster
447 ipfiremake squid
448 ipfiremake squid-graph
449 ipfiremake squidguard
450 ipfiremake calamaris
451 ipfiremake tcpdump
452 ipfiremake traceroute
453 ipfiremake vlan
454 ipfiremake wireless
455 ipfiremake libsafe
456 ipfiremake pakfire
457 ipfiremake java
458 ipfiremake spandsp
459 ipfiremake lzo
460 ipfiremake openvpn
461 ipfiremake pammysql
462 ipfiremake cups
463 ipfiremake ghostscript
464 ipfiremake foomatic
465 ipfiremake samba
466 ipfiremake sudo
467 ipfiremake mc
468 ipfiremake wget
469 ipfiremake bridge-utils
470 ipfiremake screen
471 ipfiremake hddtemp
472 ipfiremake smartmontools
473 ipfiremake htop
474 ipfiremake postfix
475 ipfiremake fetchmail
476 ipfiremake cyrus-imapd
477 ipfiremake openmailadmin
478 ipfiremake clamav
479 ipfiremake spamassassin
480 ipfiremake amavisd
481 ipfiremake alsa
482 ipfiremake mpg123
483 ipfiremake mpfire
484 ipfiremake guardian
485 ipfiremake libid3tag
486 ipfiremake libmad
487 ipfiremake libogg
488 ipfiremake libvorbis
489 ipfiremake lame
490 ipfiremake sox
491 ipfiremake libshout
492 ipfiremake icecast
493 ipfiremake icegenerator
494 ipfiremake mpd
495 ipfiremake mpc
496 ipfiremake xvid
497 ipfiremake libmpeg2
498 ipfiremake videolan
499 ipfiremake libpri
500 ipfiremake asterisk
501 ipfiremake gnump3d
502 ipfiremake libsigc++
503 ipfiremake applejuice
504 ipfiremake ocaml
505 ipfiremake mldonkey
506 ipfiremake libtorrent
507 ipfiremake rtorrent
508 ipfiremake ipfireseeder
509 ipfiremake rsync
510 ipfiremake tcpwrapper
511 ipfiremake portmap
512 ipfiremake nfs
513 ipfiremake nmap
514 ipfiremake mbmon
515 ipfiremake ncftp
516 ipfiremake etherwake
517 ipfiremake bwm-ng
518 ipfiremake tripwire
519 ipfiremake sysstat
520 ipfiremake vsftpd
521 ipfiremake which
522 ipfiremake lsof
523 ipfiremake centerim
524 ipfiremake br2684ctl
525 }
526
527 buildinstaller() {
528 # Run installer scripts one by one
529 LOGFILE="$BASEDIR/log/_build.installer.log"
530 export LOGFILE
531 ipfiremake syslinux
532 ipfiremake as86
533 ipfiremake mbr
534 ipfiremake memtest
535 installmake linux-libc-header
536 installmake binutils
537 ipfiremake uClibc PASS=1
538 ipfiremake gcc INST=1
539 installmake uClibc PASS=2
540 installmake gcc INST=2
541 installmake uClibc PASS=3
542 installmake busybox
543 installmake udev
544 installmake slang
545 installmake newt
546 installmake gettext
547 installmake kbd
548 installmake popt
549 installmake sysvinit
550 installmake misc-progs
551 installmake libaal
552 installmake reiser4progs
553 installmake reiserfsprogs
554 installmake sysfsutils
555 installmake util-linux
556 installmake pciutils
557 installmake zlib
558 installmake mtd
559 installmake wget
560 installmake hwdata
561 installmake kudzu
562 installmake installer
563 installmake initrd
564 }
565
566 buildpackages() {
567 LOGFILE="$BASEDIR/log/_build.packages.log"
568 export LOGFILE
569 echo "... see detailed log in _build.*.log files" >> $LOGFILE
570
571 installmake strip
572
573 # Generating list of packages used
574 echo -n "Generating packages list from logs" | tee -a $LOGFILE
575 rm -f $BASEDIR/doc/packages-list
576 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
577 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
578 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
579 fi
580 done
581 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
582 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
583 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
584 rm -f $BASEDIR/doc/packages-list
585 # packages-list.txt is ready to be displayed for wiki page
586 beautify message DONE
587
588 # Create images for install
589 ipfiremake cdrom ED=full
590
591 # Check if there is a loop device for building in virtual environments
592 if [ -e /dev/loop/0 ] || [ -e /dev/loop0 ]; then
593 ipfiremake usb-stick
594 fi
595 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
596
597 ipfirepackages
598
599 # Cleanup
600 stdumount
601 rm -rf $BASEDIR/build/tmp/*
602
603 # Generating total list of files
604 echo -n "Generating files list from logs" | tee -a $LOGFILE
605 rm -f $BASEDIR/log/FILES
606 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
607 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
608 echo "##" >>$BASEDIR/log/FILES
609 echo "## `basename $i`" >>$BASEDIR/log/FILES
610 echo "##" >>$BASEDIR/log/FILES
611 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
612 fi
613 done
614 beautify message DONE
615
616 cd $PWD
617 }
618
619 ipfirepackages() {
620 ipfiremake core-updates
621 for i in $(ls -1 $BASEDIR/config/rootfiles/packages); do
622 if [ -e $BASEDIR/lfs/$i ]; then
623 ipfiredist $i
624 else
625 echo -n $i
626 beautify message SKIP
627 fi
628 done
629 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
630 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
631 rm -rf $BASEDIR/build/install/packages/*
632 }
633
634 # See what we're supposed to do
635 case "$1" in
636 build)
637 clear
638 BUILDMACHINE=`uname -m`
639 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
640 #only restore on a clean disk
641 if [ ! -f log/cleanup-toolchain-2-tools ]; then
642 if [ ! -n "$PACKAGE" ]; then
643 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
644 prepareenv
645 buildtoolchain
646 else
647 PACKAGENAME=${PACKAGE%.tar.gz}
648 beautify build_stage "Packaged toolchain compilation"
649 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
650 tar zxf $PACKAGE
651 prepareenv
652 else
653 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
654 fi
655 fi
656 else
657 echo -n "Using installed toolchain" | tee -a $LOGFILE
658 beautify message SKIP
659 prepareenv
660 fi
661
662 beautify build_start
663 beautify build_stage "Building LFS"
664 buildbase
665
666 beautify build_stage "Building IPFire"
667 buildipfire
668
669 # Setzen des IPFire Builds
670 if [ "$FIREBUILD" ]; then
671 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
672 else
673 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
674 fi
675
676 beautify build_stage "Building installer"
677 buildinstaller
678
679 beautify build_stage "Building packages"
680 buildpackages
681 beautify build_end
682 ;;
683 shell)
684 # enter a shell inside LFS chroot
685 # may be used to changed kernel settings
686 prepareenv
687 entershell
688 ;;
689 changelog)
690 echo -n "Loading new Changelog from SVN: "
691 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
692 beautify message DONE
693 ;;
694 clean)
695 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
696 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
697 $LOSETUP -d $i 2>/dev/null
698 done
699 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
700 umount $i
701 done
702 stdumount
703 for i in `seq 0 7`; do
704 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
705 umount /dev/loop${i} 2>/dev/null;
706 losetup -d /dev/loop${i} 2>/dev/null;
707 fi;
708 done
709 rm -rf $BASEDIR/build
710 rm -rf $BASEDIR/cdrom
711 rm -rf $BASEDIR/packages
712 rm -rf $BASEDIR/log
713 if [ -h /tools ]; then
714 rm -f /tools
715 fi
716 beautify message DONE
717 ;;
718 downloadsrc)
719 if [ ! -d $BASEDIR/cache ]; then
720 mkdir $BASEDIR/cache
721 fi
722 mkdir -p $BASEDIR/log
723 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
724 FINISHED=0
725 cd $BASEDIR/lfs
726 for c in `seq $MAX_RETRIES`; do
727 if (( FINISHED==1 )); then
728 break
729 fi
730 FINISHED=1
731 cd $BASEDIR/lfs
732 for i in *; do
733 if [ -f "$i" -a "$i" != "Config" ]; then
734 echo -ne "Loading $i"
735 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
736 if [ $? -ne 0 ]; then
737 beautify message FAIL
738 FINISHED=0
739 else
740 if [ $c -eq 1 ]; then
741 beautify message DONE
742 fi
743 fi
744 fi
745 done
746 done
747 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
748 ERROR=0
749 for i in *; do
750 if [ -f "$i" -a "$i" != "Config" ]; then
751 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
752 if [ $? -ne 0 ]; then
753 echo -ne "MD5 difference in lfs/$i"
754 beautify message FAIL
755 ERROR=1
756 fi
757 fi
758 done
759 if [ $ERROR -eq 0 ]; then
760 echo -ne "${BOLD}all files md5sum match${NORMAL}"
761 beautify message DONE
762 else
763 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
764 beautify message FAIL
765 fi
766 cd - >/dev/null 2>&1
767 ;;
768 toolchain)
769 clear
770 prepareenv
771 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
772 buildtoolchain
773 BUILDMACHINE=`uname -m`
774 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
775 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
776 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
777 build/{bin,etc,usr/bin,usr/local} \
778 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
779 log >> $LOGFILE
780 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
781 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
782 stdumount
783 ;;
784 gettoolchain)
785 BUILDMACHINE=`uname -m`
786 # arbitrary name to be updated in case of new toolchain package upload
787 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
788 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
789 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
790 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
791 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
792 cd $BASEDIR/cache/toolchains
793 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
794 if [ $? -ne 0 ]; then
795 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
796 else
797 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
798 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
799 else
800 exiterror "$PACKAGE.md5 did not match, check downloaded package"
801 fi
802 fi
803 else
804 echo "Toolchain is already downloaded. Exiting..."
805 fi
806 ;;
807 othersrc)
808 prepareenv
809 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
810 chroot $LFS /tools/bin/env -i HOME=/root \
811 TERM=$TERM PS1='\u:\w\$ ' \
812 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
813 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
814 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
815 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
816 if [ $? -eq "0" ]; then
817 beautify message DONE
818 else
819 beautify message FAIL
820 fi
821 stdumount
822 ;;
823 svn)
824 case "$2" in
825 update|up)
826 # clear
827 echo -ne "Loading the latest source files...\n"
828 if [ $3 ]; then
829 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
830 else
831 svn update | tee -a $PWD/log/_build.svn.update.log
832 fi
833 if [ $? -eq "0" ]; then
834 beautify message DONE
835 else
836 beautify message FAIL
837 exit 1
838 fi
839 echo -ne "Writing the svn-info to a file"
840 svn info > $PWD/svn_status
841 if [ $? -eq "0" ]; then
842 beautify message DONE
843 else
844 beautify message FAIL
845 exit 1
846 fi
847 chmod 755 $0
848 exit 0
849 ;;
850 commit|ci)
851 clear
852 if [ -f /usr/bin/mcedit ]; then
853 export EDITOR=/usr/bin/mcedit
854 fi
855 if [ -f /usr/bin/nano ]; then
856 export EDITOR=/usr/bin/nano
857 fi
858 echo -ne "Selecting editor $EDITOR..."
859 beautify message DONE
860 if [ -e /sbin/yast ]; then
861 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
862 $0 changelog
863 fi
864 fi
865 update_langs
866 svn commit
867 $0 svn up
868 if [ -n "$FTP_CACHE_URL" ]; then
869 $0 uploadsrc
870 fi
871 ;;
872 dist)
873 if [ $3 ]; then
874 SVN_REVISION=$3
875 fi
876 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
877 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
878 exit 0
879 fi
880 echo -en "REV $SVN_REVISION: Downloading..."
881 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
882 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
883 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
884 evaluate 1
885
886 echo -en "REV $SVN_REVISION: Compressing files..."
887 if [ -e ipfire-source/trunk/make.sh ]; then
888 chmod 755 ipfire-source/trunk/make.sh
889 fi
890 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
891 evaluate 1
892 echo -en "REV $SVN_REVISION: Cleaning up..."
893 rm ipfire-source/ -r
894 evaluate 1
895 ;;
896 diff|di)
897 update_langs
898 echo -ne "Make a local diff to last svn revision"
899 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
900 evaluate 1
901 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
902 svn status
903 ;;
904 esac
905 ;;
906 uploadsrc)
907 PWD=`pwd`
908 cd $BASEDIR/cache/
909 echo -e "Uploading cache to ftp server:"
910 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL/$FTP_CACHE_PATH/ > /tmp/ftplist
911 for i in *; do
912 if [ "$(basename $i)" == "toolchains" ]; then continue; fi
913 grep -q $(basename $i) /tmp/ftplist
914 if [ "$?" -ne "0" ]; then
915 echo -ne "$(basename $i)"
916 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $(basename $i)
917 if [ "$?" -ne "0" ]; then
918 beautify message FAIL
919 fi
920 fi
921 done
922 rm -f /tmp/ftplist
923 cd $PWD
924 exit 0
925 ;;
926 upload)
927 FTP_ISO_PORT=`echo "$FTP_ISO_URL" | awk -F: '{ print $2 }'`
928 FTP_ISO_URL=`echo "$FTP_ISO_URL" | awk -F: '{ print $1 }'`
929 if [ -z $FTP_ISO_PORT ]; then
930 FTP_ISO_PORT=21
931 fi
932 cat <<EOF > .ftp-commands
933 mkdir -p $FTP_ISO_PATH$SVN_REVISION
934 mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
935 quit
936 EOF
937 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL < .ftp-commands
938 rm -f .ftp-commands
939
940 case "$2" in
941 iso)
942 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
943
944 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
945 for i in svn_status ipfire-source-r$SVN_REVISION.tar.gz ipfire-$VERSION.$MACHINE-full.iso ipfire-$VERSION.$MACHINE-full.iso.md5 ipfire-$VERSION.$MACHINE-devel.iso ipfire-$VERSION.$MACHINE-devel.iso.md5; do
946 if [ -e "$i" ]; then
947 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ $i
948 if [ "$?" -eq "0" ]; then
949 echo "The file with name $i was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
950 else
951 echo "There was an error while uploading the file $i to the ftp server."
952 exit 1
953 fi
954 fi
955 done
956 rm -f ipfire-$VERSION.$MACHINE-full.iso.md5
957 if [ "$3" = "--with-sources-cd" ]; then
958 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
959 fi
960 ;;
961 paks)
962 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
963 if [ "$?" -eq "0" ]; then
964 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
965 else
966 echo -e "There was an error while uploading the packages to the ftp server."
967 exit 1
968 fi
969 ;;
970 esac
971 ;;
972 batch)
973 if [ "$2" = "--background" ]; then
974 batch_script
975 exit $?
976 fi
977 if [ `screen -ls | grep -q ipfire` ]; then
978 echo "Build is already running, sorry!"
979 exit 1
980 else
981 if [ "$2" = "--rebuild" ]; then
982 export IPFIRE_REBUILD=1
983 echo "REBUILD!"
984 else
985 export IPFIRE_REBUILD=0
986 fi
987 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
988 screen -dmS ipfire $0 batch --background
989 evaluate 1
990 exit 0
991 fi
992 ;;
993 watch)
994 watch_screen
995 ;;
996 pxe)
997 case "$2" in
998 start)
999 start_tftpd
1000 ;;
1001 stop)
1002 stop_tftpd
1003 ;;
1004 reload|restart)
1005 reload_tftpd
1006 ;;
1007 esac
1008 exit 0
1009 ;;
1010 lang)
1011 update_langs
1012 ;;
1013 "")
1014 clear
1015 svn info
1016 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1017 do
1018 case $name in
1019 "IPFIRE: Downloadsrc")
1020 $0 downloadsrc
1021 ;;
1022 "IPFIRE: Build (silent)")
1023 $0 build-silent
1024 ;;
1025 "IPFIRE: Watch Build")
1026 $0 watch
1027 ;;
1028 "IPFIRE: Batch")
1029 $0 batch
1030 ;;
1031 "IPFIRE: Clean")
1032 $0 clean
1033 ;;
1034 "SVN: Update")
1035 $0 svn update
1036 ;;
1037 "Help")
1038 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1039 cat doc/make.sh-usage
1040 ;;
1041 "LOG: Tail")
1042 tail -f log/_*
1043 ;;
1044 "Exit")
1045 break
1046 ;;
1047 esac
1048 done
1049 ;;
1050 config)
1051 make_config
1052 ;;
1053 *)
1054 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1055 cat doc/make.sh-usage
1056 ;;
1057 esac